// Copyright 2020 the Kilo authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by informer-gen. DO NOT EDIT.

package v1alpha1

import (
	time "time"

	kilov1alpha1 "github.com/squat/kilo/pkg/k8s/apis/kilo/v1alpha1"
	versioned "github.com/squat/kilo/pkg/k8s/clientset/versioned"
	internalinterfaces "github.com/squat/kilo/pkg/k8s/informers/internalinterfaces"
	v1alpha1 "github.com/squat/kilo/pkg/k8s/listers/kilo/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// PeerInformer provides access to a shared informer and lister for
// Peers.
type PeerInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1alpha1.PeerLister
}

type peerInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
}

// NewPeerInformer constructs a new informer for Peer type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewPeerInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredPeerInformer(client, resyncPeriod, indexers, nil)
}

// NewFilteredPeerInformer constructs a new informer for Peer type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredPeerInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options v1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.KiloV1alpha1().Peers().List(options)
			},
			WatchFunc: func(options v1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.KiloV1alpha1().Peers().Watch(options)
			},
		},
		&kilov1alpha1.Peer{},
		resyncPeriod,
		indexers,
	)
}

func (f *peerInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredPeerInformer(client, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *peerInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&kilov1alpha1.Peer{}, f.defaultInformer)
}

func (f *peerInformer) Lister() v1alpha1.PeerLister {
	return v1alpha1.NewPeerLister(f.Informer().GetIndexer())
}
